//>-Gun To Clip
$Clip[Blaster] = HandClip;
$Clip[Chaingun] = ChainClip;
$Clip[AssaultRifle] = AssaultClip;
$Clip[Shotgun] = ShotgunClip;

//>-How Many Bullets in a Clip
$ClipSize[Blaster] = 10;
$ClipSize[Chaingun] = 20;
$ClipSize[AssaultRifle] = 25;
$ClipSize[Shotgun] = 4;

//>-ReLoading Time for each weapon 
$ClipTime[Blaster] = 2.5;
$ClipTime[chaingun] = 1.4;
$ClipTime[AssaultRifle] = 1.9;
$ClipTime[Shotgun] = 2.5;

ItemData Clip
{
	description = "Clip";
	showInventory = false;
};

function Clip::onDrop(%player,%item)
{
	if($matchStarted) {
		%count = Player::getItemCount(%player,%item);
		if(%count > 0) {
			%obj = newObject("","Item",%item,1,false);
			schedule("Item::Pop(" @ %obj @ ");", $ItemPopTime, %obj);
			addToSet("MissionCleanup", %obj);
			GameBase::throw(%obj,%player,20,false);
			Item::playPickupSound(%obj);
			Player::decItemCount(%player,%item,1);
			return %obj;
		}
	}
}

function Clip::onUse(%player, %item)
{
	%client = Player::getclient(%player);
	%weapon = Player::getMountedItem(%player, $WeaponSlot);
	%clip = $Clip[%weapon];
	if(Player::getItemCount(%player, %weapon) != 0) {
		if(Player::getItemCount(%player, %Clip) > 0)
			Reload(%player,%weapon,$ClipTime[%weapon]);
		else {
			if(%clip != "")
				bottomprint(%client, "<jc><f1>[<f2>Out of Clips<f1>]", 2);
		}
	}
}

function Reload(%player,%weapon,%RDPer)
{
	%client = Player::getclient(%player);
	$Reloading[%client] = 1;
	Player::unMountItem(%player, %weapon);
	bottomprint(%client, "<jc><f3>R<f2>e<f3>l<f2>o<f3>a<f2>d<f3>i<f2>n<f3>g<f2>.<f3>.<f2>.<f3>.", %RDPer);
	schedule("Player::setAnimation("@%player@"," @9@");", %RDPer-1.13);
	schedule("Player::setItemCount("@%player@"," @%weapon.imageType.ammoType@"," @$ClipSize[%weapon]@");",%RDPer/2);
	schedule("Player::MountItem("@%player@ "," @%weapon@ "," @$WeaponSlot@ ");", %RDPer);
	Player::decItemCount(%player, $Clip[%weapon]);
	schedule("$Reloading["@%client@"] = 0;",%RDPer++);
}

function Weapon::onUse(%player,%item)
{
	%client = Player::getclient(%player);
	if(%player.Station == "") {
		%ammo = %item.imageType.ammoType;
		Player::mountItem(%player,%item,$WeaponSlot);
		Weapon::descriptionMSG(%client,%item);
		if(%ammo < 0 && $Clip[%item] < 0)
			bottomprint(%client,"<jc><f1>[Out of Clips]", 2);
		if(%ammo < 0 && $Clip[%item] > 0)
			Player::useItem(%player,$Clip[%item]);
	}
}

function Weapon::descriptionMSG(%clientId,%item)
{
	if(!$SinglePlayer && $Reloading[%client] != 1 && $ShowWeapMountMsg[%clientId] != false) {
		if($FireModes[%item] == "")
			bottomprint(%clientId,$WeapMountMSG[%item],3);
		else {
			%CurMode = $WeapMode[%clientId,%item];
			if(%CurMode == "")
				%CurMode = 1;
			bottomprint(%clientId,$WeapMountMSG[%item,%CurMode],3);
		}
	}
}

function Player::onNoAmmo(%player,%imageSlot,%itemType)
{
	%clip = $Clip[%itemType];
	%clipCount = Player::getItemCount(%player,%clip);
	if(%clipCount > 0)
		Player::useItem(%player,%clip);
	else {
		if(%clip != "") 
			bottomprint(Player::getClient(%player), "<jc><f1>[<f2>Out of Clips<f1>]", 2);
	}
}

//-The Magazine's Image

ItemData HandClip
{
        description = "9.mm Clip";
        className = "Clip";
        shapeFile = "ammo1";
        heading = "xAmmunition";
        shadowdetailmask = 4;
        price = 30;
};

ItemData ChainClip
{
        description = "HK-31 Clip";
        className = "Clip";
        shapeFile = "ammo1";
        heading = "xAmmunition";
        shadowdetailmask = 4;
        price = 10;
};

ItemData AssaultClip
{
        description = "Assault Clip";
        className = "Clip";
        shapeFile = "ammo1";
        heading = "xAmmunition";
        shadowdetailmask = 4;
        price = 20;
};

ItemData ShotgunClip
{
        description = "Shotgun Clip";
        className = "Clip";
        shapeFile = "ammo1";
        heading = "xAmmunition";
        shadowdetailmask = 4;
        price = 25;
};

//-Just the Inventory Stuff
$ItemMax[larmor, HandClip] = 2;
$ItemMax[marmor, HandClip] = 4;
$ItemMax[harmor, HandClip] = 8;
$ItemMax[lfemale, HandClip] = 1;
$ItemMax[mfemale, HandClip] = 8;
$ItemMax[sarmor, HandClip] = 8;
$ItemMax[barmor, HandClip] = 8;
$ItemMax[warmor, HandClip] = 0;
$ItemMax[earmor, HandClip] = 8;
$ItemMax[efemale, HandClip] = 8;
$ItemMax[darmor, HandClip] = 8;
$ItemMax[sfemale, HandClip] = 8;
$ItemMax[bfemale, HandClip] = 8;
$ItemMax[wfemale, HandClip] = 0;
$ItemMax[spyarmor, HandClip] = 8;
$ItemMax[spyfemale, HandClip] = 8;
$InvList[HandClip] = 1;

$ItemMax[larmor, ChainClip] = 4;
$ItemMax[marmor, ChainClip] = 5;
$ItemMax[harmor, ChainClip] = 8;
$ItemMax[lfemale, ChainClip] = 1;
$ItemMax[mfemale, ChainClip] = 8;
$ItemMax[sarmor, ChainClip] = 8;
$ItemMax[barmor, ChainClip] = 8;
$ItemMax[warmor, ChainClip] = 5;
$ItemMax[earmor, ChainClip] = 8;
$ItemMax[efemale, ChainClip] = 8;
$ItemMax[darmor, ChainClip] = 8;
$ItemMax[sfemale, ChainClip] = 8;
$ItemMax[bfemale, ChainClip] = 8;
$ItemMax[wfemale, ChainClip] = 5;
$ItemMax[spyarmor, ChainClip] = 8;
$ItemMax[spyfemale, ChainClip] = 8;
$InvList[ChainClip] = 1;

$ItemMax[larmor, AssaultClip] = 2;
$ItemMax[marmor, AssaultClip] = 3;
$ItemMax[harmor, AssaultClip] = 8;
$ItemMax[lfemale, AssaultClip] = 1;
$ItemMax[mfemale, AssaultClip] = 8;
$ItemMax[sarmor, AssaultClip] = 8;
$ItemMax[barmor, AssaultClip] = 8;
$ItemMax[warmor, AssaultClip] = 0;
$ItemMax[earmor, AssaultClip] = 8;
$ItemMax[efemale, AssaultClip] = 8;
$ItemMax[darmor, AssaultClip] = 8;
$ItemMax[sfemale, AssaultClip] = 8;
$ItemMax[bfemale, AssaultClip] = 8;
$ItemMax[wfemale, AssaultClip] = 0;
$ItemMax[spyarmor, AssaultClip] = 8;
$ItemMax[spyfemale, AssaultClip] = 8;
$InvList[AssaultClip] = 1;

$ItemMax[larmor, ShotgunClip] = 3;
$ItemMax[marmor, ShotgunClip] = 4;
$ItemMax[harmor, ShotgunClip] = 8;
$ItemMax[lfemale, ShotgunClip] = 1;
$ItemMax[mfemale, ShotgunClip] = 8;
$ItemMax[sarmor, ShotgunClip] = 8;
$ItemMax[barmor, ShotgunClip] = 8;
$ItemMax[warmor, ShotgunClip] = 4;
$ItemMax[earmor, ShotgunClip] = 8;
$ItemMax[efemale, ShotgunClip] = 8;
$ItemMax[darmor, ShotgunClip] = 8;
$ItemMax[sfemale, ShotgunClip] = 8;
$ItemMax[bfemale, ShotgunClip] = 8;
$ItemMax[wfemale, ShotgunClip] = 4;
$ItemMax[spyarmor, ShotgunClip] = 8;
$ItemMax[spyfemale, ShotgunClip] = 8;
$InvList[ShotgunClip] = 1;